package main

import (
	"context"
	"log/slog"
	"os"

	"borodyadka.dev/borodyadka/minireader/internal/minireader"
)

func main() {
	app, err := minireader.New()
	if err != nil {
		slog.Error("failed to init application", "error", err)
		os.Exit(1)
	}

	ctx, cancel := context.WithCancel(context.Background())
	defer cancel()

	if err := app.Start(ctx); err != nil {
		app.Logger().Error("failed to start application", "error", err)
		os.Exit(1)
	}
}
