package repositories

import (
	"context"

	"github.com/google/uuid"

	"borodyadka.dev/borodyadka/minireader/internal/minireader/dto"
	"borodyadka.dev/borodyadka/minireader/internal/minireader/repositories/sql"
)

type SubscriptionRepository struct {
}

func NewSubscriptionRepository() *SubscriptionRepository {
	return &SubscriptionRepository{}
}

func (r *SubscriptionRepository) Create(ctx context.Context, user *dto.User, feed uuid.UUID) error {
	return sql.New(ConnFromContext(ctx)).CreateSubscription(ctx, sql.CreateSubscriptionParams{
		UserID: user.ID,
		FeedID: feed,
	})
}

func (r *SubscriptionRepository) Update(ctx context.Context, user *dto.User, feed uuid.UUID, input dto.UpdateFeed) (bool, error) {
	return false, nil
}

func (r *SubscriptionRepository) Delete(ctx context.Context, user *dto.User) (bool, error) {
	return false, nil
}

func (r *SubscriptionRepository) CountByFeed(ctx context.Context, feed uuid.UUID) (int, error) {
	return 0, nil
}
